#ifndef __INITIAL_H__
#define __INITIAL_H__

#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"
#include "GroupFromAnnotation.h"
#include "MathMatrix.h"
#include "StringHash.h"

class Meta
{
    public:
        Meta();
        ~Meta();

        //Input/Output options  
	static String studyName;
	static String prefix;
	static bool outvcf;
	static bool Burden;
	static bool MB;
	static bool SKAT;
	static bool VTa;
	static bool VTp;
	static bool report;
	static bool fullResult;
	static bool founderAF;
	static double CALLRATE;
	static double  report_pvalue_cutoff;
	static double MAF_cutoff;
	static double HWE;

	//saved single variant information from pooled studies
	StringArray studies; //studies has all study names prefix
	//flipSNP has all SNPs fliped saved. Key is study:chr:pos, value is an integer
	//SNPexclude has all SNPs with non-consistent ref/alt alleles saved. key is study:chr:pos; value is an integer
	StringIntHash flipSNP,SNPexclude;
	StringDoubleHash SNPmaf,singleVarPvalue,singleVarEff;
	StringDoubleHash SNPstat,SNP_Vstat; //SNPstat has the single variants stats for all SNPs 
	//	StringIntHash * SNPexclude;

	IntArray SampleSize;
	int total_N;

	void Run(GroupFromAnnotation & group);
	void PoolSummaryStat();
	void Prepare();
	double GetBetaDensity(double a, double b, double x);
	double CalculateCorrCoef(Vector & a,Vector & b);
};

#endif
